//#include <Init_mimi.mqh>
#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1 Black
#property indicator_color2 Lime
#property indicator_color3 Red
#property indicator_color4 Yellow
#property indicator_color5 Lime
#property indicator_color6 Red

extern bool ALERTS = TRUE;
extern bool SoundAlerts = TRUE;
extern string SoundAlertFile = "alert.wave";
extern bool eMailAlerts = TRUE;
int BarsCount;
int Level = 21;
double Buffer1[];
double Buffer2[];
double Buffer3[];
double Buffer4[];
double Buffer5[];
double Buffer6[];

// Init
int init() {
   SetIndexStyle(0, DRAW_NONE);
   SetIndexStyle(1, DRAW_LINE, EMPTY, 3);
   SetIndexStyle(2, DRAW_LINE, EMPTY, 3);
   SetIndexStyle(3, DRAW_LINE, EMPTY, 3);
   SetIndexStyle(4, DRAW_ARROW, EMPTY, 2);
   SetIndexArrow(4, 225);
   SetIndexStyle(5, DRAW_ARROW, EMPTY, 2);
   SetIndexArrow(5, 226);
   IndicatorDigits(Digits + 0);
   SetIndexBuffer(0, Buffer1);
   SetIndexBuffer(1, Buffer2);
   SetIndexBuffer(2, Buffer3);
   SetIndexBuffer(3, Buffer4);
   SetIndexBuffer(4, Buffer5);
   SetIndexBuffer(5, Buffer6);
   IndicatorShortName("Profit Signal");
   SetIndexLabel(0, NULL);
   SetIndexLabel(1, NULL);
   SetIndexLabel(2, NULL);
   SetIndexLabel(3, NULL);
   SetIndexLabel(4, NULL);
   return (0);
}

// Main Part
int start() {
   double Var0;
   double Var8;
   double Var16;
   string Var104;
   string Var112;
   string Var120;
   int Var24 = IndicatorCounted();
   double Var28 = 0;
   double Var36 = 0;
   double Var44 = 0;
   double Var52 = 0;
   double Var60 = 0;
   double Var68 = 0;
   double LowSignal= 0;
   double HighSignal= 0;
   if (Var24 > 0) Var24--;
   int i2 = Bars - Var24;
   for (int i = 0; i < i2; i++) {
      HighSignal = High[iHighest(NULL, 0, MODE_HIGH, Level, i)];
      LowSignal= Low[iLowest(NULL, 0, MODE_LOW, Level, i)];
      Var16 = (High[i] + Low[i]) / 2.0;
      Var28 = 0.66 * ((Var16 - LowSignal) / (HighSignal - LowSignal) - 0.5) + 0.67 * Var36;
      Var28 = MathMin(MathMax(Var28, -0.999), 0.999);
      Buffer1[i] = MathLog((Var28 + 1.0) / (1 - Var28)) / 2.0 + Var60 / 2.0;
      Var36 = Var28;
      Var60 = Buffer1[i];
   }
   bool True100 = TRUE;
   for (i = i2 - 2; i >= 0; i--) {
      Buffer4[i] = 0;
      Var8 = Buffer1[i + 1];
      Var0 = Buffer1[i + 2];
      if ((Var8 < 0.0 && Var0 > 0.0) || Var8 < 0.0) {
         True100 = FALSE;
         if (Var8 < 0.0 && Var0 > 0.0) {
            Var104 = Symbol() + ", TF:" + CaseString(Period());
            Var112 = Var104 + ", SELL SIGNAL";
            Var120 = Var112 + " @ " + TimeToStr(TimeLocal(), TIME_SECONDS);
            if (Bars > BarsCount) {
               BarsCount = Bars;
               TextString(Var120, Var112);
            }
         }
      }
      if ((Var8 > 0.0 && Var0 < 0.0) || Var8 > 0.0) {
         True100 = TRUE;
         if (Var8 > 0.0 && Var0 < 0.0) {
            Var104 = Symbol() + ", TF:" + CaseString(Period());
            Var112 = Var104 + ",BUY SIGNAL";
            Var120 = Var112 + " @ " + TimeToStr(TimeLocal(), TIME_SECONDS);
            if (Bars > BarsCount) {
               BarsCount = Bars;
               TextString(Var120, Var112);
            }
         }
      }
      if (!True100) {
         Buffer3[i] = Var8;
         Buffer2[i] = 0.0;
      } else {
         Buffer2[i] = Var8;
         Buffer3[i] = 0.0;
      }
   }
   for (i = 0; i < i2; i++) {
      if (Buffer2[i] > 0.0 && Buffer2[i + 1] == 0.0) Buffer5[i] = Buffer2[i];
      if (Buffer3[i] < 0.0 && Buffer3[i + 1] == 0.0) Buffer6[i] = Buffer3[i];
   }
   return (0);
}

// Texts
void TextString(string As_0, string As_8) {
   if (ALERTS) Alert(As_0);
   if (SoundAlerts) PlaySound(SoundAlertFile);
   if (eMailAlerts) SendMail(As_8, As_0);
}

// Cases
string CaseString(int Case) {
   switch (Case) {
   case 1:
      return ("M1");
   case 5:
      return ("M5");
   case 15:
      return ("M15");
   case 30:
      return ("M30");
   case 60:
      return ("H1");
   case 240:
      return ("H4");
   case 1440:
      return ("D1");
   case 10080:
      return ("W1");
   case 43200:
      return ("MN1");
   }
   
   WindowRedraw();
   return (Period());
}